/******************************************************************************
 * instrument.c
 * Federico Bareilles
 * 31/01/2003
 *
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "tipper_red.h"


/*** A/D Calibration ***/
static char *ad_file[]={
  "ad6.dat","ad6.dat","ad6.dat","ad6.dat","ad6.dat","ad6.dat","ad6.dat"};
/*** A/D reference voltage at Pin 28, measured relative to TP1 (mV). ***/
/*** NOTE: Vref for unit 5 is not known. 4500 is an average          ***/
/*** OK: Unit 5 is measured at IAR, it is now 4416.6 mV              ***/
float vref1_ADC[7]={4500.0,4510.0,4470.0,4490.0,4510.0,4416.6,4521.0};

/*** PROBLEMS WITH SR3, VREF MAY HAVE CHANGED TO 5V 9601.27          ***/
/***  + SR3 SETTING vref2_ADC TO 5V APPEARS TO FIX LOW VOLTAGE       ***/
/***    MEASUREMENTS. NO TRANSITION DATA TO FIT vref2_ADC VALUE.     ***/
/***    THE SENCOND Vref WAS SET BY MATCHING Vgunn TO THE SHIPPING   ***/
/***    CHECK SHEET.					             ***/
/***  + SR5 REAL FLAKEY, DETERMIND vref2_ADC BY FITTING TO REAL      ***/
/***    su950818 data.  					     ***/
float vref2_ADC[7]={4500.0,4510.0,4470.0,5055.0,4510.0,4955.0,4521.0};

/*** A/D analog ground voltage at Pin 27, measureds relative to      ***/
/*** TP1 (mV) with the stepper motor off.			     ***/
float agrd_ADC[7] = {6.0,6.0,6.0,6.0,6.0,6.0,6.0};

struct instrument *set_instrument(int unit)
{
  struct instrument *t;
  
  t = (struct instrument *) malloc(sizeof(struct instrument));
  t->unit      = unit;
  t->ad_file   = ad_file[unit];
  t->vref1_ADC = vref1_ADC[unit];
  t->vref2_ADC = vref2_ADC[unit];
  t->agrd_ADC  = agrd_ADC[unit];
  /* Set lookup table to correct for zener non_linearities at ADC input */
  t->zt        = get_table_zener(t);
  
  return t;
}

int free_instrument(struct instrument *t)
{
  free_zener_table(t);
  free(t);

  return 0;
}
 
